Package org.eclipse.emf.cdo.spi.server

# Class RepositoryConfigurator

java.lang.Object
org.eclipse.emf.cdo.spi.server.RepositoryConfigurator

All Implemented Interfaces:
  `org.eclipse.net4j.util.container.IManagedContainerProvider`

public class RepositoryConfigurator extends Object implements org.eclipse.net4j.util.container.IManagedContainerProvider
If the meaning of this type isn't clear, there really should be more of a description here...

Since:
  4.0
Author:
  Eike Stepper

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`RepositoryConfigurator.Extension`
Can use `cdo-server.xml` markup elements to configure extended aspects of a `repository`.
`static class`
`RepositoryConfigurator.Factory`
`static class`
`RepositoryConfigurator.TreeExtension`
A repository configurator `extension` that

## Constructor Summary

Constructors
Constructor
Description
`RepositoryConfigurator()`
`RepositoryConfigurator(org.eclipse.net4j.util.container.IManagedContainer container)`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`addOperationAuthorizer(InternalRepository repository, String type, String description)`
`protected void`
`addOperationAuthorizers(InternalRepository repository, Element repositoryConfig)`
`IRepository[]`
`configure(File configFile)`
`IRepository[]`
`configure(Reader configReader)`
`protected IRepository[]`
`configure(Document document)`
`protected IStore`
`createStore(String repositoryName, Map<String,String> repositoryProperties, Element storeConfig)`
`static String`
`expandValue(String value, Map<String,String> parameters, org.eclipse.net4j.util.container.IManagedContainer container)`
`static void`
`forEachChildElement(Element element, String name, org.eclipse.net4j.util.XMLUtil.ElementHandler handler)`
`protected String`
`getAttribute(Element element, String name)`
`protected org.eclipse.net4j.util.security.IAuthenticator`
`getAuthenticator(String type, String description)`
`protected org.eclipse.net4j.util.security.IAuthenticator`
`getAuthenticator(Element authenticatorConfig)`
`protected Element`
`getAuthenticatorConfig(Element repositoryConfig)`
`protected Element`
`getChildElement(Element element, String name)`
`org.eclipse.net4j.util.container.IManagedContainer`
`getContainer()`
`protected <T> T`
`getContainerElement(Element element, String defaultType)`
`protected Document`
`getDocument(File configFile)`
`protected Document`
`getDocument(Reader configReader)`
`protected EPackage[]`
`getInitialPackages(Element repositoryConfig)`
`protected org.eclipse.net4j.util.security.operations.OperationAuthorizer<ISession>`
`getOperationAuthorizer(String type, String description)`
`String`
`getParameter(String key)`
`static Map<String,String>`
`getProperties(Element element, int levels)`
`static Map<String,String>`
`getProperties(Element element, int levels, Map<String,String> parameters)`
`static Map<String,String>`
`getProperties(Element element, int levels, Map<String,String> parameters, org.eclipse.net4j.util.container.IManagedContainer container)`
`protected IRepository`
`getRepository(String repositoryType)`
`protected IRepository`
`getRepository(Element repositoryConfig)`
`Map<String,IRepositoryFactory>`
`getRepositoryFactories()`
`protected IRepositoryFactory`
`getRepositoryFactory(String type)`
`protected Element`
`getStoreConfig(Element repositoryConfig)`
`Map<String,IStoreFactory>`
`getStoreFactories()`
`protected IStoreFactory`
`getStoreFactory(String type)`
`protected org.eclipse.net4j.util.security.IUserManager`
`getUserManager(String type, String description)`
`protected org.eclipse.net4j.util.security.IUserManager`
`getUserManager(Element userManagerConfig)`
`protected Element`
`getUserManagerConfig(Element repositoryConfig)`
`protected void`
`setActivityLog(InternalRepository repository, Element repositoryConfig)`
`protected void`
`setAuthenticator(InternalRepository repository, Element repositoryConfig)`
`String`
`setParameter(String key, String value)`
`protected void`
`setUserManager(InternalRepository repository, Element repositoryConfig)`
`static String`
`substituteParameters(String str, Map<String,String> parameters)`
Deprecated.
As of 4.20 use `StringUtil.replace(String, Map)`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RepositoryConfigurator

public RepositoryConfigurator()

### RepositoryConfigurator

public RepositoryConfigurator(org.eclipse.net4j.util.container.IManagedContainer container)

## Method Details

### getContainer

public org.eclipse.net4j.util.container.IManagedContainer getContainer()

Specified by:
  `getContainer` in interface `org.eclipse.net4j.util.container.IManagedContainerProvider`

### getRepositoryFactories

public Map<String,IRepositoryFactory> getRepositoryFactories()

### getStoreFactories

public Map<String,IStoreFactory> getStoreFactories()

### getParameter

public String getParameter(String key)

Since:
  4.10

### setParameter

public String setParameter(String key, String value)

Since:
  4.10

### configure

public IRepository[] configure(File configFile) throws ParserConfigurationException, SAXException, IOException, CoreException

Throws:
  `ParserConfigurationException`
  `SAXException`
  `IOException`
  `CoreException`

### configure

public IRepository[] configure(Reader configReader) throws ParserConfigurationException, SAXException, IOException, CoreException

Throws:
  `ParserConfigurationException`
  `SAXException`
  `IOException`
  `CoreException`
Since:
  4.3

### configure

protected IRepository[] configure(Document document) throws ParserConfigurationException, SAXException, IOException, CoreException

Throws:
  `ParserConfigurationException`
  `SAXException`
  `IOException`
  `CoreException`
Since:
  4.3

### getDocument

protected Document getDocument(File configFile) throws ParserConfigurationException, SAXException, IOException

Throws:
  `ParserConfigurationException`
  `SAXException`
  `IOException`

### getDocument

protected Document getDocument(Reader configReader) throws ParserConfigurationException, SAXException, IOException

Throws:
  `ParserConfigurationException`
  `SAXException`
  `IOException`
Since:
  4.3

### getRepositoryFactory

protected IRepositoryFactory getRepositoryFactory(String type) throws CoreException

Throws:
  `CoreException`

### getRepository

protected IRepository getRepository(Element repositoryConfig) throws CoreException

Throws:
  `CoreException`

### getRepository

protected IRepository getRepository(String repositoryType) throws CoreException

Throws:
  `CoreException`

### getUserManagerConfig

protected Element getUserManagerConfig(Element repositoryConfig)

### getUserManager

protected org.eclipse.net4j.util.security.IUserManager getUserManager(Element userManagerConfig) throws CoreException

Throws:
  `CoreException`

### getUserManager

protected org.eclipse.net4j.util.security.IUserManager getUserManager(String type, String description) throws CoreException

Throws:
  `CoreException`

### setUserManager

protected void setUserManager(InternalRepository repository, Element repositoryConfig) throws CoreException

Throws:
  `CoreException`
Since:
  4.2

### getAuthenticatorConfig

protected Element getAuthenticatorConfig(Element repositoryConfig)

Since:
  4.2

### getAuthenticator

protected org.eclipse.net4j.util.security.IAuthenticator getAuthenticator(Element authenticatorConfig) throws CoreException

Throws:
  `CoreException`
Since:
  4.2

### getAuthenticator

protected org.eclipse.net4j.util.security.IAuthenticator getAuthenticator(String type, String description) throws CoreException

Throws:
  `CoreException`
Since:
  4.2

### setAuthenticator

protected void setAuthenticator(InternalRepository repository, Element repositoryConfig) throws CoreException

Throws:
  `CoreException`
Since:
  4.2

### addOperationAuthorizers

protected void addOperationAuthorizers(InternalRepository repository, Element repositoryConfig) throws CoreException

Throws:
  `CoreException`
Since:
  4.15

### addOperationAuthorizer

protected void addOperationAuthorizer(InternalRepository repository, String type, String description) throws CoreException

Throws:
  `CoreException`
Since:
  4.24

### getOperationAuthorizer

protected org.eclipse.net4j.util.security.operations.OperationAuthorizer<ISession> getOperationAuthorizer(String type, String description) throws CoreException

Throws:
  `CoreException`
Since:
  4.15

### setActivityLog

protected void setActivityLog(InternalRepository repository, Element repositoryConfig)

Since:
  4.7

### getInitialPackages

protected EPackage[] getInitialPackages(Element repositoryConfig)

### getStoreConfig

protected Element getStoreConfig(Element repositoryConfig)

### getStoreFactory

protected IStoreFactory getStoreFactory(String type) throws CoreException

Throws:
  `CoreException`

### createStore

protected IStore createStore(String repositoryName, Map<String,String> repositoryProperties, Element storeConfig) throws CoreException

Throws:
  `CoreException`

### getContainerElement

protected <T> T getContainerElement(Element element, String defaultType)

Since:
  4.7

### getChildElement

protected Element getChildElement(Element element, String name)

Since:
  4.10

### getAttribute

protected String getAttribute(Element element, String name)

Since:
  4.10

### forEachChildElement

public static void forEachChildElement(Element element, String name, org.eclipse.net4j.util.XMLUtil.ElementHandler handler) throws Exception

Throws:
  `Exception`
Since:
  4.20

### expandValue

public static String expandValue(String value, Map<String,String> parameters, org.eclipse.net4j.util.container.IManagedContainer container)

Since:
  4.20

### getProperties

public static Map<String,String> getProperties(Element element, int levels)

### getProperties

public static Map<String,String> getProperties(Element element, int levels, Map<String,String> parameters)

Since:
  4.10

### getProperties

public static Map<String,String> getProperties(Element element, int levels, Map<String,String> parameters, org.eclipse.net4j.util.container.IManagedContainer container)

Since:
  4.20

### substituteParameters

@Deprecated public static String substituteParameters(String str, Map<String,String> parameters)
Deprecated.
As of 4.20 use `StringUtil.replace(String, Map)`.

Since:
  4.10